Index: plugins/widgets/index.php
===================================================================
--- plugins/widgets/index.php	(revision 1179)
+++ plugins/widgets/index.php	(revision 1669)
@@ -165,9 +165,9 @@
   <?php echo file_get_contents(dirname(__FILE__).'/style.css'); ?>
   </style>
-  <script type="text/javascript" src="js/tool-man/core.js"></script>
-  <script type="text/javascript" src="js/tool-man/events.js"></script>
-  <script type="text/javascript" src="js/tool-man/css.js"></script>
-  <script type="text/javascript" src="js/tool-man/coordinates.js"></script>
-  <script type="text/javascript" src="js/tool-man/drag.js"></script>
+  <?php
+		echo
+			dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+			dcPage::jsLoad('index.php?pf=widgets/widgets.js');
+  ?>
   <?php 
 	$core->auth->user_prefs->addWorkspace('accessibility'); 
@@ -177,5 +177,4 @@
   <script type="text/javascript" src="index.php?pf=widgets/dragdrop.js"></script>
   <?php endif; ?>
-  <script type="text/javascript" src="index.php?pf=widgets/widgets.js"></script>
   <script type="text/javascript">
   //<![CDATA[
@@ -188,30 +187,34 @@
 <body>
 <?php
-echo '<h2>'.html::escapeHTML($core->blog->name).' &rsaquo; <span class="page-title">'.__('Widgets').'</span></h2>';
+echo dcPage::breadcrumb(
+	array(
+		html::escapeHTML($core->blog->name) => '',
+		'<span class="page-title">'.__('Widgets').'</span>' => ''
+	));
 
 # All widgets
 echo
 '<form id="listWidgets" action="'.$p_url.'" method="post"  class="widgets">'.
-'<fieldset><legend>'.__('Available widgets').'</legend>'.
-'<div id="widgets">';
+'<h3>'.__('Available widgets').'</h3>'.
+'<p>'.__('Move widgets from this list to one of the sidebars.').'</p>'.
+'<ul id="widgets-ref">';
 
 $j = 0;
 foreach ($__widgets->elements(true) as $w) {
 	echo
-	'<div>'.form::hidden(array('w[void][0][id]'),html::escapeHTML($w->id())).
-	'<p class="widget-name">'.form::field(array('w[void][0][order]'),2,3,0,'hideControl').' '.
-	$w->name().($w->desc() != '' ? ' <span class="form-note">('.__($w->desc()).')</span>' : '').'</p>'.
-	'<p class="js-remove"><label class="classic">'.__('Append to:').' '.
-	form::combo(array('addw['.$w->id().']'),$append_combo).'</label></p>'.
-	'<div class="widgetSettings">'.$w->formSettings('w[void][0]',$j).'</div>'.
-	'</div>';
+	'<li>'.form::hidden(array('w[void][0][id]'),html::escapeHTML($w->id())).
+	'<p class="widget-name">'.form::field(array('w[void][0][order]'),2,3,0,'hide','',0,'title="'.__('order').'"').' '.$w->name().
+	($w->desc() != '' ? ' <span class="form-note">'.__($w->desc()).'</span>' : '').'</p>'.
+	'<p class="manual-move remove-if-drag"><label class="classic">'.__('Append to:').'</label> '.
+	form::combo(array('addw['.$w->id().']'),$append_combo).'</p>'.
+	'<div class="widgetSettings hidden-if-drag">'.$w->formSettings('w[void][0]',$j).'</div>'.
+	'</li>';
 	$j++;
 }
 
 echo
-'</div>'.
-'</fieldset>'.
-'<p><input type="submit" class="js-remove" name="append" value="'.__('Add widgets to sidebars').'" />'.
-$core->formNonce().'</p>'.
+'</ul>'.
+$core->formNonce().
+'<p class="remove-if-drag"><input type="submit" name="append" value="'.__('Add widgets to sidebars').'" /></p>'.
 '</form>';
 
@@ -219,19 +222,19 @@
 # Nav sidebar
 echo
-'<div id="sidebarNav" class="widgets">'.
-sidebarWidgets('dndnav',__('Navigation sidebar'),$widgets_nav,'nav',$__default_widgets['nav'],$j).
-'</div>';
+'<div id="sidebarNav" class="widgets fieldset">'.
+sidebarWidgets('dndnav',__('Navigation sidebar'),$widgets_nav,'nav',$__default_widgets['nav'],$j);
+echo '</div>';
 
 # Extra sidebar
 echo
-'<div id="sidebarExtra" class="widgets">'.
-sidebarWidgets('dndextra',__('Extra sidebar'),$widgets_extra,'extra',$__default_widgets['extra'],$j).
-'</div>';
+'<div id="sidebarExtra" class="widgets fieldset">'.
+sidebarWidgets('dndextra',__('Extra sidebar'),$widgets_extra,'extra',$__default_widgets['extra'],$j);
+echo '</div>';
 
 # Custom sidebar
 echo
-'<div id="sidebarCustom" class="widgets">'.
-sidebarWidgets('dndcustom',__('Custom sidebar'),$widgets_custom,'custom',$__default_widgets['custom'],$j).
-'</div>';
+'<div id="sidebarCustom" class="widgets fieldset">'.
+sidebarWidgets('dndcustom',__('Custom sidebar'),$widgets_custom,'custom',$__default_widgets['custom'],$j);
+echo '</div>';
 
 echo
@@ -248,5 +251,5 @@
 'drag it from the Available widgets list on the left to one of the sidebars on the right of this page. You can order '.
 'your widgets in a sidebar by dragging them up or down. You must update sidebars to apply your changes.').'</p>'.
-'<p>'.__('Once included in a sidebar, widgets have configuration options that you can reach by clicking on the + sign next '.
+'<p>'.__('Once included in a sidebar, widgets have configuration options that you can reach by clicking on the arrow next '.
 'to their name.').'</p>'.
 '<p>'.__('Reset sidebars to get back to default widgets installation.').'</p>'.
@@ -312,5 +315,5 @@
 function sidebarWidgets($id,$title,$widgets,$pr,$default_widgets,&$j)
 {
-	$res = '<fieldset><legend>'.$title.'</legend><div id="'.$id.'">';
+	$res = '<h3>'.$title.'</h3>';
 	
 	if (!($widgets instanceof dcWidgets))
@@ -319,7 +322,7 @@
 	}
 	
-	if ($widgets->isEmpty()) {
-		$res .= '<p class="empty-widgets">'.__('No widget.').'</p>';
-	}
+	$res .= '<p class="empty-widgets" '.(!$widgets->isEmpty() ? 'style="display: none;"' : '').'>'.__('No widget.').'</p>';
+	
+	$res .= '<ul id="'.$id.'" class="connected">';
 	
 	$i = 0;
@@ -329,12 +332,12 @@
 		
 		$res .=
-		'<div>'.form::hidden(array($iname.'[id]'),html::escapeHTML($w->id())).
-		'<p class="widget-name">'.form::field(array($iname.'[order]'),2,3,(string) $i,'js-hide','',0,'title="'.__('order').'"').' '.
-		$w->name().($w->desc() != '' ? ' <span class="form-note">('.__($w->desc()).')</span>' : '').'</p>'.
-		'<p class="removeWidget js-remove"><label class="classic">'.
+		'<li>'.form::hidden(array($iname.'[id]'),html::escapeHTML($w->id())).
+		'<p class="widget-name">'.form::field(array($iname.'[order]'),2,3,(string) $i,'hidden-if-drag','',0,'title="'.__('order').'"').' '.$w->name().
+		($w->desc() != '' ? ' <span class="form-note">'.__($w->desc()).'</span>' : '').'</p>'.
+		'<p class="removeWidget remove-if-drag"><label class="classic">'.
 		form::checkbox(array($iname.'[_rem]'),'1',0).' '.__('Remove widget').
 		'</label></p>'.
-		'<div class="widgetSettings">'.$w->formSettings($iname,$j).'</div>'.
-		'</div>';
+		'<div class="widgetSettings hidden-if-drag">'.$w->formSettings($iname,$j).'</div>'.
+		'</li>';
 		
 		$i++;
@@ -342,5 +345,10 @@
 	}
 	
-	$res .= '</div></fieldset>';
+	$res .= '</ul>';
+
+	if ($i > 0) {
+		$res .= '<ul class="sortable-delete"><li class="sortable-delete-placeholder">'.
+			__('Drag widgets here to remove them from this sidebar.').'</li></ul>';
+	}
 	
 	return $res;
Index: plugins/widgets/widgets.js
===================================================================
--- plugins/widgets/widgets.js	(revision 665)
+++ plugins/widgets/widgets.js	(revision 1661)
@@ -1,227 +1,71 @@
-var dragdrop = ToolMan.dragdrop();
-$(function() {
+/*
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+*/
+
+dotclear.postExpander = function(line) {
+	var title = $(line).find('.widget-name');
+	title.find('.form-note').remove();
+	order = title.find('input[name*=order]');
+	link = $('<a href="#" alt="expand" class="aexpand"/>').append(title.text());
+	title.empty().append(order).append(link);
+	
+	var img = document.createElement('img');
+	img.src = dotclear.img_plus_src;
+	img.alt = dotclear.img_plus_alt;
+	img.className = 'expand';
+	$(img).css('cursor','pointer');
+	img.onclick = function() { dotclear.viewPostContent($(this).parents('li')); };
+	link.click(function(e) {
+		e.preventDefault();
+		dotclear.viewPostContent($(this).parents('li'));
+	});
+	
+	title.prepend(img);
+};
+
+dotclear.viewPostContent = function(line,action) {
+	var action = action || 'toogle';
+	var img = line.find('.expand');
+	var isopen = img.attr('alt') == dotclear.img_plus_alt;
+	
+	if( action == 'close' || ( action == 'toogle' && !isopen ) ) {
+		line.find('.widgetSettings').hide();
+		img.attr('src', dotclear.img_plus_src);
+		img.attr('alt', dotclear.img_plus_alt);
+	} else if ( action == 'open' || ( action == 'toogle' && isopen ) ) {
+		line.find('.widgetSettings').show();
+		img.attr('src', dotclear.img_minus_src);
+		img.attr('alt', dotclear.img_minus_alt);
+	}
+	
+};
+
+$(function() {	
+	// reset
 	$('input[name="wreset"]').click(function() {
 		return window.confirm(dotclear.msg.confirm_widgets_reset);
 	});
+	
+	// plier/déplier
+	$('#dndnav > li, #dndextra > li, #dndcustom > li').each(function() {
+		dotclear.postExpander(this);
+		dotclear.viewPostContent($(this), 'close');
+	});
+	
+	// remove
+	$('input[name*=rem]').change(function () {
+	    if ($(this).attr("checked")) {
+	        $(this).parents('li').remove();
+	    }
+	});
+	
 });
-
-$(function() {
-	var widgets = document.getElementById('widgets');
-	var w_nav = document.getElementById('dndnav');
-	var w_ext = document.getElementById('dndextra');
-	var w_custom = document.getElementById('dndcustom');
-	
-	w_nav.className = 'hideControls';
-	w_ext.className = 'hideControls';
-	w_custom.className = 'hideControls';
-	
-	removeElements(document.getElementById('listWidgets'),'input');
-	removeElements(widgets,'p');
-	removeElements(w_nav,'p');
-	removeElements(w_ext,'p');
-	removeElements(w_custom,'p');
-	hideElements(w_nav,'input');
-	hideElements(w_ext,'input');
-	hideElements(w_custom,'input');
-	
-	configControls(w_nav);
-	configControls(w_ext);
-	configControls(w_custom);
-	
-	dragdrop.makeListContainer(widgets,'div',setHandle);
-	if (!document.all) { widgets.factory = true; }
-	dragdrop.makeListContainer(w_nav,'div',setHandle);
-	w_nav.onDragEnd = navDragEnd;
-	dragdrop.makeListContainer(w_ext,'div',setHandle);
-	w_ext.onDragEnd = extraDragEnd;
-	dragdrop.makeListContainer(w_custom,'div',setHandle);
-	w_custom.onDragEnd = customDragEnd;
-	
-	// Helper to remove some elements
-	function removeElements(p,name) {
-		name = name || 'div';
-		$(p).find(name+'.js-remove').each(function() {
-			this.parentNode.removeChild(this);
-		});
-	}
-	
-	// Helper to hide elements (but keep them)
-	function hideElements(p,name) {
-		name = name || 'div';
-		$(p).find(name+'.js-hide').each(function() {
-			$(this).toggle();
-		});
-	}	
-	
-	function removeEmptyMsg(p) {
-		$(p).find('p.empty-widgets').each(function() {
-			this.parentNode.removeChild(this);
-		});
-	}
-	
-	// Events on dragEnd
-	function navDragEnd() {
-		formControls(this.parentNode,'nav');
-		configControls(this.parentNode);
-		removeEmptyMsg(this.parentNode);
-	}
-	function extraDragEnd() {
-		formControls(this.parentNode,'extra');
-		configControls(this.parentNode);
-		removeEmptyMsg(this.parentNode);
-	}
-	function customDragEnd() {
-		formControls(this.parentNode,'custom');
-		configControls(this.parentNode);
-		removeEmptyMsg(this.parentNode);
-	}
-	
-	// dragEnd helper
-	function formControls(e,pr) {
-		var items = new Array();
-		for (var i=0; i<e.childNodes.length; i++) {
-			if (e.childNodes[i].nodeType == 1 && e.childNodes[i].nodeName.toLowerCase() == 'div') {
-				items.push(e.childNodes[i]);
-			}
-		}
-		
-		var fields, itype;
-		var r = new RegExp('^w\[[a-z]+]\[[0-9]+][[](.+?)]$','');
-		for (i=0; i<items.length; i++) {
-			// Change field names
-			fields = getFormControls(items[i]);
-			var j;
-			var f;
-			for (j=0; j<fields.length; j++) {
-				if (r.test(fields[j].name)) {
-					itype = fields[j].name.replace(r,'$1');
-					
-					$(fields[j]).attr('name','w['+pr+']['+i+']['+itype+']');
-					
-					if (itype == 'order') {
-						fields[j].value = i;
-					}
-				}
-			}
-		}
-	}
-	
-	function getFormControls(e) {
-		var input = e.getElementsByTagName('input');
-		var textarea = e.getElementsByTagName('textarea');
-		var select = e.getElementsByTagName('select');
-		var items = new Array();
-		var i;
-		for (i=0; i<input.length; i++) { items.push(input[i]); }
-		for (i=0; i<select.length; i++) { items.push(select[i]); }
-		for (i=0; i<textarea.length; i++) { items.push(textarea[i]); }
-		
-		return items;
-	}
-	
-	function configControls(e) {
-		var items = new Array();
-		for (var i=0; i<e.childNodes.length; i++) {
-			if (e.childNodes[i].nodeType == 1 && e.childNodes[i].nodeName.toLowerCase() == 'div') {
-				items.push(e.childNodes[i]);
-			}
-		}
-		
-		var title, img_ctrl, img, space;
-		for (i in items) {
-			// Append config control
-			title = $('p.widget-name',items[i]).get(0);
-			img_ctrl = title.firstChild;
-			
-			// There already an image
-			if (img_ctrl.nodeName.toLowerCase() == 'img') {
-				continue;
-			}
-			
-			// Nothing to configure
-			if (title.nextSibling.childNodes.length == 0) {
-				continue;
-			}
-			
-			img = document.createElement('img');
-			img.src = dotclear.img_plus_src;
-			img.alt = dotclear.img_plus_alt;
-			img.control = title.nextSibling;
-			img.onclick = function() { widgetConfig.call(this); };
-			space = document.createTextNode(' ');
-			title.insertBefore(img,img_ctrl);
-			title.insertBefore(space,img_ctrl);
-		}
-	}
-	
-	function widgetConfig() {
-		if (this.control.style.display == 'block') {
-			this.control.style.display = 'none';
-			this.src = dotclear.img_plus_src;
-			this.alt = dotclear.img_plus_alt;
-		} else {
-			this.control.style.display = 'block';
-			this.src = dotclear.img_minus_src;
-			this.alt = dotclear.img_minus_alt;
-		}
-	}
-	
-	function setHandle(item) {
-		//var handle = item.getElementsByTagName('h4').item(0);
-		var handle = $('p.widget-name',item).get(0);
-		$(handle).addClass('handler');
-		item.toolManDragGroup.setHandle(handle);
-	}
-});
-
-//
-// For Safari, we need to make a hard copy of the form and submit copy.
-// Yeah, a simple clone of the form is not enough
-// I hate this browser!
-//
-if (document.childNodes && !document.all && !navigator.taintEnabled)
-{
-	$(function() {
-		$('#sidebarsWidgets').submit(function() {
-			// Create a new form and copy each element inside
-			var f = document.createElement('form');
-			f.action = this.action;
-			f.method = this.method;
-			$(f).hide();
-			var fset = document.createElement('fieldset');
-			f.appendChild(fset);
-			
-			document.body.appendChild(f);
-			
-			$(this).find('input').each(function() {
-				var i = document.createElement('input');
-				i.type = this.type;
-				i.name = this.name;
-				i.value = this.value;
-				if (this.type == 'checkbox') {
-					i.checked = this.checked;
-				}
-				fset.appendChild(i);
-			});
-			
-			$(this).find('textarea').each(function() {
-				var i = document.createElement('textarea');
-				i.name = this.name;
-				i.value = this.value;
-				fset.appendChild(i);
-			});
-			
-			$(this).find('select').each(function() {
-				var i = document.createElement('input');
-				i.name = this.name;
-				i.value = this.value;
-				fset.appendChild(i);
-			});
-			
-			$(fset).append('<input type="hidden" name="wup" value="1"/>');
-			f.submit();
-			
-			return false;
-		});
-	});
-}
Index: tests/functional/js/fix_include.js
===================================================================
--- tests/functional/js/fix_include.js	(revision 1602)
+++ tests/functional/js/fix_include.js	(revision 1602)
@@ -0,0 +1,9 @@
+var dotclear = dotclear || {};
+dotclear.img_plus_src = '../../admin/images/expand.png';
+dotclear.img_plus_alt = 'uncover';
+dotclear.img_minus_src = '../../admin/images/hide.png';
+dotclear.img_minus_alt = 'hide';
+
+jQuery.cookie = function() {};
+jQuery.fn.backgroundFade = function() {};
+
Index: tests/functional/js/plugins.js
===================================================================
--- tests/functional/js/plugins.js	(revision 1602)
+++ tests/functional/js/plugins.js	(revision 1602)
@@ -0,0 +1,83 @@
+var dotclear = {};
+dotclear.img_plus_src = '../../admin/images/expand.png';
+dotclear.img_plus_alt = 'uncover';
+dotclear.img_minus_src = '../../admin/images/hide.png';
+dotclear.img_minus_alt = 'hide';
+
+jQuery.fn.toggleWithLegend = function(target,s) {
+	var defaults = {
+		img_on_src: dotclear.img_plus_src,
+		img_on_alt: dotclear.img_plus_alt,
+		img_off_src: dotclear.img_minus_src,
+		img_off_alt: dotclear.img_minus_alt,
+		hide: true,
+		speed: 0,
+		legend_click: false,
+		fn: false, // A function called on first display,
+		cookie: false,
+		reverse_cookie: false // Reverse cookie behavior
+	};
+	var p = jQuery.extend(defaults,s);
+
+	if (!target) { return this; }
+
+	var set_cookie = p.hide ^ p.reverse_cookie;
+	if (p.cookie && jQuery.cookie(p.cookie)) {
+		p.hide = p.reverse_cookie;
+	}
+
+	var toggle = function(i,speed) {
+		speed = speed || 0;
+		if (p.hide) {
+			$(i).get(0).src = p.img_on_src;
+			$(i).get(0).alt = p.img_on_alt;
+			target.hide(speed);
+		} else {
+			$(i).get(0).src = p.img_off_src;
+			$(i).get(0).alt = p.img_off_alt;
+			target.show(speed);
+			if (p.fn) {
+				p.fn.apply(target);
+				p.fn = false;
+			}
+		}
+
+		if (p.cookie && set_cookie) {
+			if (p.hide ^ p.reverse_cookie) {
+				jQuery.cookie(p.cookie,'',{expires: -1});
+			} else {
+				jQuery.cookie(p.cookie,1,{expires: 30});
+			}
+		}
+
+		p.hide = !p.hide;
+	};
+
+	return this.each(function() {
+		var i = document.createElement('img');
+		i.src = p.img_off_src;
+		i.alt = p.img_off_alt;
+		var a = document.createElement('a');
+		a.href= '#';
+		$(a).append(i);
+		$(a).css({
+			border: 'none',
+			outline: 'none'
+		});
+
+		var ctarget = p.legend_click ? this : a;
+
+		$(ctarget).css('cursor','pointer');
+		if (p.legend_click) {
+			$(ctarget).find('label').css('cursor','pointer');
+		}
+		$(ctarget).click(function() {
+			toggle(i,p.speed);
+			return false;
+		});
+
+
+		toggle($(i).get(0));
+		$(this).prepend(' ').prepend(a);
+	});
+};
